#!/usr/bin/perl

#---- CHDIR to script-dir (no -x needed)
BEGIN
{
 use Cwd;
 use std;
 my $abs_file = std::rx_g(Cwd::abs_path($0),"\\\\","/");
 chdir(substr($abs_file,0,rindex($abs_file,"/")+1));
}

#---- Use's
use std;
use Tk;
use Tk::Icon;
use Tk::NoteBook;
use Tk::LabFrame;
use Tk::BrowseEntry;
use Tk::StatusBar;
use Tk::Balloon;
use Win32::GUI;
use Win32::GuiTest;
use Win32::Clipboard;
use Time::HiRes;
use vk_codes;
use Math::Trig;
use Math::Complex;

#---- API Use's
use Win32::API;
use Win32::API::Callback;
#my $RegisterRawInputDevices = Win32::API->new('User32.dll','RegisterRawInputDevices','PII'  ,'I',);
#my $GetRawInputDeviceList   = Win32::API->new('User32.dll','GetRawInputDeviceList'  ,'IPI'  ,'I',);
#my $GetRawInputData         = Win32::API->new('User32.dll','GetRawInputData'        ,'IIPPI','I',);
#my $GetRawInputBuffer       = Win32::API->new('User32.dll','GetRawInputBuffer'      ,'PPI'  ,'I',);
my $EnumDisplayMonitors = Win32::API->new('User32.dll', 'EnumDisplayMonitors','IIKI'        ,'I');
my $GetMonitorInfo      = Win32::API->new('User32.dll', 'GetMonitorInfo'     ,'IP'          ,'I');
my $CreateDC                   = Win32::API->new('Gdi32.dll','CreateDCA','PIII','I');
my $CreateCompatibleBitmap     = Win32::API->new('Gdi32.dll','CreateCompatibleBitmap','III','I');
my $BitBlt                     = Win32::API->new('Gdi32.dll','BitBlt','IIIIIIIII','I');
my $StretchBlt                 = Win32::API->new('Gdi32.dll','StretchBlt','IIIIIIIIIII','I');
my $CreateCompatibleDC         = Win32::API->new('Gdi32.dll','CreateCompatibleDC','I','I');
my $DeleteDC                   = Win32::API->new('Gdi32.dll','DeleteDC','I','I');
my $DeleteObject               = Win32::API->new('Gdi32.dll','DeleteObject','I','I');
my $SelectObject               = Win32::API->new('Gdi32.dll','SelectObject','II','I');
my $SetLayeredWindowAttributes = Win32::API->new('User32.dll','SetLayeredWindowAttributes','IIII','I');
my $SetWindowsHookEx       = new Win32::API('User32.dll'  ,'SetWindowsHookEx'       ,'IKII','I');
my $UnhookWindowsHookEx    = new Win32::API('User32.dll'  ,'UnhookWindowsHookEx'    ,'I','I');
my $CallNextHookEx         = new Win32::API('User32.dll'  ,'CallNextHookEx'         ,'IIII','I');
my $ShowCursor             = new Win32::API('User32.dll'  ,'ShowCursor'         ,'I','I');
my $SetSystemCursor     = Win32::API->new('User32.dll', 'SetSystemCursor', 'II', 'I',);
my $LoadCursor          = Win32::API->new('User32.dll', 'LoadCursor', 'II', 'I',);
my $CopyImage           = Win32::API->new('User32.dll', 'CopyImage', 'IIIII', 'I',);
my $LoadCursorFromFile  = Win32::API->new('User32.dll', 'LoadCursorFromFile', 'P', 'I',); 
my $keybd_event         = Win32::API->new('User32.dll','keybd_event','IIII','I');
my $SetProcessDpiAwareness = Win32::API->new('Shcore.dll','SetProcessDpiAwareness','I','I');
my $SetProcessDPIAware = Win32::API->new('User32.dll','SetProcessDPIAware','','I');
my $GetPhysicalCursorPos = new Win32::API('User32.dll','GetPhysicalCursorPos','P','I');
my $SetPhysicalCursorPos = new Win32::API('User32.dll','SetPhysicalCursorPos','P','I');
my $GetCursorPos = new Win32::API('User32.dll','GetCursorPos','P','I');
my $SetCursorPos = new Win32::API('User32.dll','SetPhysicalCursorPos','II','I');
my $GetKeyboardState = new Win32::API('User32.dll','GetKeyboardState','P','I');
my $SetKeyboardState = new Win32::API('User32.dll','SetKeyboardState','P','I');

#---- glob's
my $version = "0.3";
my %config = split("\n",std::readfile("config/config_save.txt"));
my $shootmode = 0;
my ($shootX,$shootY);
#my $blockmouse = 0;
my $circlefix_onoff = 0;
my $circling_onoff = 0;

#---------------- stop multi-instances
exit Win32::GUI::MessageBox(0,"Another instance of Circlefix is running.\nPlease close it first.\nIf you can't see it look for a Trayicon. (right-side in taskbar)\nClose it with a right-click to the icon.","Problem",MB_OK|MB_ICONASTERISK) if (grep(Win32::GUI::GetClassName($_) eq "TkTopLevel" && index(Win32::GuiTest::GetWindowText($_),"Circlefix v") == 0,Win32::GuiTest::GetChildWindows(0)) != 0);

#---- multimonitor system - desktop sizes
my $ret = $SetProcessDpiAwareness->Call(2); print "dpi_ret:$ret\n"; # vor mainwindow damit $mw->screenheight stimmt
my @displayinfo_array;
my $MONITORINFOEX = pack("I", 72).("\x00" x 72);
my $MonitorEnumProc = Win32::API::Callback->new(sub{ $GetMonitorInfo->Call($_[0],$MONITORINFOEX); push(@displayinfo_array,[unpack("i4",unpack("P16",pack("I",$_[2])))]); }, "NNNN", "I");
$EnumDisplayMonitors->Call(0,0,$MonitorEnumProc,0);

#---- monitor choices hash with centerposes
my %monitorchoices;
my $mcount = 1;
foreach my $data (@displayinfo_array)
{
 my ($l,$t,$r,$b) = @$data;
 $monitorchoices{"Monitor ".$mcount} = [($r-$l)/2+$l,($b-$t)/2+$t];
 $mcount++;
}
($config{posx},$config{posy}) = @{$monitorchoices{$config{centercircle}}} if ($config{centercircle} =~ m/^Monitor \d/);

#==== create tk window
#my $ret = $SetProcessDpiAwareness->Call(2); print "dpi_ret:$ret\n"; # vor mainwindow damit $mw->screenheight stimmt
my $mw = MainWindow->new();
$mw->optionAdd('*font', '{Comic Sans MS} 10');
$mw->title('Circlefix v'.$version);
$mw->setIcon(-file => 'images/pointer.ico');
$mw->protocol('WM_DELETE_WINDOW',sub{$mw->state('withdraw')});

#---- load shortcuts file
my %shortcuts;
sub load_shortcuts
{
 foreach my $data (std::readfile_array_nobr("config/shortcuts.txt"))
 {
  my ($key,$distance,$mousespeed,$mousemode,$posx,$posy) = split("\t",$data);
  $shortcuts{$vk_codes{$key}}{distance} = $distance if ($distance =~ m/^[\d\.]+$/);
  $shortcuts{$vk_codes{$key}}{mousespeed} = $mousespeed if ($mousespeed =~ m/^[\d\.]+$/);
  $shortcuts{$vk_codes{$key}}{mousemode} = $mousemode if ($mousemode =~ m/^[\d\.]+$/);
  $shortcuts{$vk_codes{$key}}{posx} = $posx if ($posx =~ m/^[\d\.]+$/);
  $shortcuts{$vk_codes{$key}}{posy} = $posy if ($posy =~ m/^[\d\.]+$/);
 }
}
load_shortcuts();
$mw->repeat(10000,\&load_shortcuts);

#---- create shootwindow
my $colorbrush = new Win32::GUI::Brush(-color => [0,0,0]);
my $shootwindow = new Win32::GUI::Window (-pos         => [100, 100],
                                         -size        => [20, 20],
                                         -popstyle       => 0x00840000,#~0,
                                         #-popexstyle     => ~0,
                                         -pushstyle       => 0x80000000,#$style & 0xEFFFFFFF,
                                         -pushexstyle     => 0x00080028,#$exstyle,
                                         -class => new Win32::GUI::Class(-name => "redrush",-brush => $colorbrush),
                                        );
$SetLayeredWindowAttributes->Call($shootwindow->{'-handle'},0,255,2);

#---- Tk::NoteBook
my $nb = $mw->NoteBook(-focuscolor => 'black')->pack(-expand => 1,-fill => 'y');
my $page1 = $nb->add('Main',-label => 'Main');#,-bitmap => 'info');
#my $page2 = $nb->add('Info',-label => 'Info');

#---- STATUSBAR
my $Label_Statusbar = "Press CTRL + S to start Circlefix.";
my $sb = $mw->StatusBar();
my $balloon_widget = $sb->addLabel(-relief => 'sunken',-textvariable => \$Label_Statusbar);
my %circlefix_onoff_labels = (1 => "KEYB. Shortcuts ON",0 => "KEYB. Shortcuts OFF");
my %circling_onoff_labels  = (1 => "Circling ON",0 => "Circling OFF");
sub SB_Info {$Label_Statusbar = $circlefix_onoff_labels{$circlefix_onoff}." / ".$circling_onoff_labels{$circling_onoff};}

#---- Page-X Balloons
my $b = $mw->Balloon(-initwait => 0,-balloonposition => 'mouse');

#---- tk felder zum einstellen der middlepos
my $config_labframe = $page1->LabFrame(-label => "Config",
                                       -padx => 5,-pady => 5,
                                       -labelside => "acrosstop")->pack(-fill => 'x');

my $config_frame = $config_labframe->Frame()->pack();
$config_frame->Label(-text => "Center Pos X: ")->grid(-column => 0,-row => 0,-sticky => 'w');
$config_frame->Label(-text => "Center Pos Y: ")->grid(-column => 0,-row => 1,-sticky => 'w');
$config_frame->Label(-text => "Center Circle: ")->grid(-column => 0,-row => 2,-sticky => 'w');
$config_frame->Label(-text => "Mouse Speed: ")->grid(-column => 0,-row => 3,-sticky => 'w');
$config_frame->Label(-text => "Circle Radius: ")->grid(-column => 0,-row => 4,-sticky => 'w');
$config_frame->Label(-text => "Mouse Mode: ")->grid(-column => 0,-row => 5,-sticky => 'w');
my $spinbox_posx = $config_frame->Spinbox(-format          => '%0.0f',
                                          -increment       => 1,
                                          -from            => 0,
                                          -to              => 10000,
                                          -command         => sub{&config_save()},
                                          -validate        => 'key',
                                          -validatecommand => sub { my ($proposed, $changes, $current, $index, $type) = @_; return 0 if $proposed !~ m/^\d+$/g; $config{centercircle} = "At Centerpos X,Y"; $mw->after(100,\&config_save); },
                                          -width           => 6 ,
                                          -textvariable    => \$config{posx})  ->grid(-column => 1,-row => 0,-sticky => 'w,e');
my $spinbox_posy = $config_frame->Spinbox(-format          => '%0.0f',
                                          -increment       => 1,
                                          -from            => 0,
                                          -to              => 10000,
                                          -command         => sub{&config_save()},
                                          -validate        => 'key',
                                          -validatecommand => sub { my ($proposed, $changes, $current, $index, $type) = @_; return 0 if $proposed !~ m/^\d+$/g; $config{centercircle} = "At Centerpos X,Y"; $mw->after(100,\&config_save); },
                                          -width           => 6,
                                          -textvariable    => \$config{posy})  ->grid(-column => 1,-row => 1,-sticky => 'w,e');
my $centercircle = $config_frame->BrowseEntry(-width              => 14,
                                              #-disabledbackground => 'lightgray',
                                              #-disabledforeground => 'gray30',
                                              -choices            => [keys %monitorchoices],
                                              -textvariable       => \$config{centercircle},
                                              -state              => 'readonly',
                                              -listheight         => 5,
                                              -buttontakefocus    => 1,
                                              #-browsecmd          => [\&movetype_change,$confnumber],
                                              -browsecmd          => sub{ ($config{posx},$config{posy}) = @{$monitorchoices{$_[1]}}; &config_save(); },
                                              -highlightcolor     => 'black',
                                              -highlightthickness => 1,
                                              -takefocus          => 1
                                             )->grid(-column => 1,-row => 2,-sticky => 'w,e');
my $mousespeed = $config_frame->Spinbox(#-format          => '%5.2f',
                                        -increment       => 0.1,
                                        -from            => 0,
                                        -to              => 10000,
                                        -command         => sub{ &config_save(); },
                                        -validate        => 'key',
                                        #-validatecommand => sub { my $x = $_[0]; $x =~ s/[^0-9\.]//g; $config{mousespeed}=$x; &config_save(); my ($proposed, $changes, $current, $index, $type) = @_; print "proposed:$proposed\n"; return 1 if ($proposed =~ m/^[\d\.]+$/); },
                                        -validatecommand => sub { my ($proposed, $changes, $current, $index, $type) = @_; return 0 if $proposed !~ m/^[\d\.]+$/g; $mw->after(100,\&config_save); },
                                        -width           => 6,
                                        #-state              => 'readonly',
                                        -textvariable    => \$config{mousespeed})  ->grid(-column => 1,-row => 3,-sticky => 'w,e');
my $distance = $config_frame->Spinbox(#-format          => '%5.2f',
                                      -increment       => 1,
                                      -from            => 0,
                                      -to              => 10000,
                                      -command         => sub{ &config_save(); },
                                      -validate        => 'key',
                                      -validatecommand => sub { my ($proposed, $changes, $current, $index, $type) = @_; return 0 if $proposed !~ m/^[\d\.]+$/g; $mw->after(100,\&config_save); },
                                      -width           => 6,
                                      #-state              => 'readonly',
                                      -textvariable    => \$config{distance})  ->grid(-column => 1,-row => 4,-sticky => 'w,e');

my $mousemode = $config_frame->Listbox(-width        => 12,
                                       -height       => 2,
                                       -listvariable => ["Circle Fixed","Circle Unfixed"],
                                    #-choices            => ["Circle Fixed","Circle Unfixed"],
                                    #-textvariable       => \$mousemode_var,
                                    #-state              => 'readonly',
                                    #-listheight         => 2,
                                    #-buttontakefocus    => 1,
                                    #-browsecmd          => [\&movetype_change,$confnumber],
                                    #-browsecmd          => sub{ print "ok\n"; },
                                    #-highlightcolor     => 'black',
                                    #-highlightthickness => 1,
                                    #-takefocus          => 1
                                   )->grid(-column => 1,-row => 5,-sticky => 'w,e');
$mousemode->selectionSet(($config{mousemode} || 0));
$mousemode->bind('<Button-1>',sub{ $config{mousemode} = ($_[0]->curselection())[0]; &config_save(); });


#---- load save conf
sub config_save()
{
 std::writefile("config/config_save.txt",join("\n",%config));
}

########################################################
########################################### TRAYICON ###
#my $hwnd = Win32::GUI::GetPerlWindow(); #Win32::GUI::Hide($hwnd);
my $icon = new Win32::GUI::Icon('images/pointer.ico');
my $main = Win32::GUI::Window->new(
    -name    => 'Main',
    -text    => 'Perl',
    -width   => 200,
    -height  => 200,
    -visible => 0,
    #-menu    => $systray_menu
);
my $ni = $main->AddNotifyIcon(
    -name => "systray",
    #-id   => $id,
    -icon => $icon,
    -tip  => "Circlefix",
);
my $systray_menu = Win32::GUI::Menu->new(
    "SystrayMenu Function" => "SystrayMenu",
    #"trayIcon",
    "> Open"              => "SystrayOpen",
    "> Info"              => "SystrayInfo",
    ">-"                  => "",
    "> Exit"              => "SystrayExit",
);

######################################################
######################################## Tray SUBS ###
sub mw_center()
{
    my $desk = Win32::GUI::GetDesktopWindow();
    my $desk_w = Win32::GUI::Width($desk);
    my $desk_h = Win32::GUI::Height($desk);
    my $window_w = $mw->width;
    my $window_h = $mw->height;
    $mw->geometry('+'.int(($desk_w / 2)-($window_w / 2)).'+'.int(($desk_h / 2)-($window_h / 2)));
}
my %winlist_id2hwnd;
sub systray_RightClick
{
 my($x, $y) = Win32::GUI::GetCursorPos();
 $main->TrackPopupMenu($systray_menu->{SystrayMenu}, $x, $y);
}
sub systray_Click
{
    $mw->state('normal');
    $mw->deiconify();#this is the real - bring on top
    #$mw->attributes(-topmost => 1);
    #$mw->attributes(-topmost => 0);
    &mw_center();
    $mw->bell();
}
sub SystrayOpen_Click
{
 $nb->raise('Main');
 $mw->state('normal');
 $mw->deiconify();#this is the real - bring on top
 &mw_center();
}
#sub SystrayInfo_Click
#{
# $nb->raise('Info');
# $mw->state('normal');
# $mw->deiconify();#this is the real - bring on top
# &mw_center();
#}
sub SystrayInfo_Click
{
 $mw->state('normal');
 $mw->deiconify();#this is the real - bring on top
 my %pages = map {$_ => 1} $nb->info("pages");
 $nb->raise('Info') if(defined $pages{Info});
 return if(defined $pages{Info});
 my $page = $nb->add('Info',-label => 'Info');#-bitmap => 'info');
 #$page_info = $page->Frame(-padx => 20,-pady => 100)->pack();
 $page_info = $page->Frame()->pack(-expand => 1,-anchor => "center");
 $nb->raise('Info');
 $page_info->Button(-bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black',-relief => 'raised',-text  => 'Close',-width => 10,-command => sub{$nb->delete('Info');$nb->raise('Main');})->pack(-anchor => 'n',-side => 'top',-expand => 0,-fill => 'x');
 my $page_info_frame = $page_info->Frame(-bg => 'white',-borderwidth => 0,-padx => 20,-pady => 10)->pack(-expand => 1,-anchor => 'center');
 my $logo = $mw->Photo(-file => "./images/pointer_centered.gif");
 $page_info_frame->Label(-bg => 'white',-border => 0,-padx => 20,-pady => 0,-image => $logo)->pack();
 $page_info_frame->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "\nCirclefix v".$version."\nDeveloped by Robert Xell.")->pack();
 my $page_info_mailframe = $page_info_frame->Frame(-bg => 'white',-border => 0,-padx => 0,-pady => 0)->pack(-anchor => 'center');
 $page_info_mailframe->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "Email: ")->pack(-side => 'left');
 my $label_mail = $page_info_mailframe->Label(-cursor => 'trek',-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 1,-size => 8],-text => "xenolux\@gmail.com")->pack(-side => 'right');
 my $page_info_urlframe = $page_info_frame->Frame(-bg => 'white',-border => 0,-padx => 0,-pady => 0)->pack(-anchor => 'center');
 $page_info_urlframe->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 0,-size => 8],-text => "Surf to: ")->pack(-side => 'left');
 my $label_url = $page_info_urlframe->Label(-cursor => 'hand2',-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 1,-size => 8],-text => "http://ynea.futureware.at")->pack(-side => 'right');
 
 $mw->bind($label_mail, '<Button-1>', sub{system(('start','"xx"','"mailto:xenolux@gmail.com"'))});
 $mw->bind($label_url , '<Button-1>', sub{system(('start','"xx"','"http://ynea.futureware.at"'))});
 $mw->bind($label_mail, '<Button-3>', sub{my $CLIP = Win32::Clipboard(); $CLIP->Set('xenolux@gmail.com');});
 $mw->bind($label_url , '<Button-3>', sub{my $CLIP = Win32::Clipboard(); $CLIP->Set('http://ynea.futureware.at');});
 $b->attach($label_mail,-balloonmsg => "Left Click: Send Mail\nRight Click: Copy to Clipboard");
 $b->attach($label_url ,-balloonmsg => "Left Click: Open Browser\nRight Click: Copy to Clipboard");
}
SystrayInfo_Click();
$nb->raise('Main');
sub SystrayExit_Click
{
    $mw->state('normal');
    my $answer = $mw->messageBox(-title   => 'Circlefix',
                                 -message => 'Do you really want to quit?',
                                 -type    => 'YesNo',
                                 -icon    => 'question',
                                 -default => 'yes');
    if ($answer =~ /y/i){
        # maybe do some cleaning up and
        #Win32::GUI::NofityIcon::Remove($ni);
        #Win32::GUI::NotifyIcon::Delete( $ni, -id =>  $id );
        $ni->Remove;
        $mw->destroy();
        #return -1;
    }
}

#---- cursordaten
#my $cursor_ori = $CopyImage->Call($LoadCursor->Call(0,32512),2,0,0,0);
#my $cursor_trans = $LoadCursorFromFile->Call('images\transparent.cur');

#---- maus an verschiedene positionen setzen  nach count
my $count = 1;
my $dist = 300;
my $height = $mw->screenheight;
my $width = $mw->screenwidth;
my $center_x = $width/2;
my $center_y = $height/2;
my $timeout = 200;
my $timeout_smallest = 200;
my $id;
my $timeout_steps = 10;
sub set_mouse_pos_rect()
{
 print "interval: set_mouse_pos_rect\n";

 #Win32::GUI::SetCursorPos($center_x,$center_y-$dist) if ($count == 1);
 #Win32::GUI::SetCursorPos($center_x-$dist,$center_y-$dist) if ($count == 2);
 #Win32::GUI::SetCursorPos($center_x-$dist,$center_y) if ($count == 3);
 #Win32::GUI::SetCursorPos($center_x-$dist,$center_y+$dist) if ($count == 4);
 #Win32::GUI::SetCursorPos($center_x,$center_y+$dist) if ($count == 5);
 #Win32::GUI::SetCursorPos($center_x+$dist,$center_y+$dist) if ($count == 6);
 #Win32::GUI::SetCursorPos($center_x+$dist,$center_y) if ($count == 7);
 #Win32::GUI::SetCursorPos($center_x+$dist,$center_y-$dist) if ($count == 8);
 Win32::GUI::SetCursorPos($center_x-$dist,$center_y-$dist) if ($count == 1);
 Win32::GUI::SetCursorPos($center_x-$dist,$center_y+$dist) if ($count == 2);
 Win32::GUI::SetCursorPos($center_x+$dist,$center_y+$dist) if ($count == 3);
 Win32::GUI::SetCursorPos($center_x+$dist,$center_y-$dist) if ($count == 4);

 $count++;
 $count = 1 if ($count > 4);
 #$timeout = $timeout - $timeout_steps if ($timeout > $timeout_smallest);
 #$id->time($timeout);
}

#---- toggle_scroll_key
sub toggle_scroll_key
{
 Win32::GuiTest::SendKeys("{SCROLL}") if ((Win32::GUI::GetKeyState(0x91))[1] != $circlefix_onoff);
}
$mw->repeat(500,\&toggle_scroll_key);

#==== keyboard hook implementierung
my $stopmove = 0;
#my $ret = $SetProcessDpiAwareness->Call(2); print "dpi_ret:$ret\n";
my ($x_old,$y_old) = (0,0);
sub LowLevelMouseProc($$$)
{
  my ($nCode, $wParam, $lParam) = @_;
  #my $vkCode   = unpack("s",(unpack("P2",pack('L!',$lParam+10))));
  #print "Maus: nCode=$nCode, wParam=$wParam, lParam=$lParam, vkCode=".$vkCode.", flags=$flags\n";

  my $blockmouse = 0;
  if ($circlefix_onoff && $wParam == 512)
  {
   if ($id ne "")
   {
    $blockmouse = 1;
   }
   else
   {
    #if ($wParam == $vk_codes{VK_MOUSE_LEFT_DOWN}) { $config{distance} = 20; $config{mousespeed} = 0.2 }
    #if ($wParam == $vk_codes{VK_MOUSE_LEFT_UP}) { $config{distance} = 300; $config{mousespeed} = 1.2 }
    if ($circling_onoff)
    {
     my ($llx,$lly) = unpack("i2",unpack("P8",pack("I",$lParam))); # lowlevel x and y pos
     #print "llx:$llx,lly:$lly\n";

     #---- beschleunigung
     my $moved_x = $llx - $x_old;
     my $moved_y = $lly - $y_old;
     #print "moved_x: $llx - $x_old = $moved_x, moved_y: $lly - $y_old = $moved_y\n";
     my $x = $x_old + ($moved_x * $config{mousespeed});
     my $y = $y_old + ($moved_y * $config{mousespeed});

     #---- centerdiff_x und centerdiff_y
     my $centerdiff_x = $x - $config{posx};
     my $centerdiff_y = $y - $config{posy};

     #---- radius
     my $centerdiff_x_pos = ($centerdiff_x < 0)?-$centerdiff_x:$centerdiff_x;
     my $centerdiff_y_pos = ($centerdiff_y < 0)?-$centerdiff_y:$centerdiff_y;
     my $r = sqrt($centerdiff_x_pos**2 + $centerdiff_y_pos**2);
     #print "r:$r\n";

     #---- position korrigieren wenn mousemode fixed oder radius groesser als eingestellt
     my ($x_new,$y_new) = ($x,$y);
     if (($config{mousemode} == 0) || ($r > $config{distance}))
     {
      #---- verhltnis korrektur
      my $verh = $r / $config{distance};
      #print "verh:$verh\n";
      $x_new = $config{posx} + ($centerdiff_x / $verh);
      $y_new = $config{posy} + ($centerdiff_y / $verh);
     }
     #$blockmouse = 1 if ($x_new != $x || $y_new != $y);
     $blockmouse = 1; # if ($r > $dist);
     Win32::GUI::SetCursorPos($x_new,$y_new) if ($blockmouse);
     ($x_old,$y_old) = ($x_new,$y_new);
    }
   }
  }

  my $hookret = $CallNextHookEx->Call(0, $nCode, $wParam, $lParam);
  return ($blockmouse || $hookret);
}
my $MouseHookCallback = Win32::API::Callback->new(\&LowLevelMouseProc, 'NNN', 'I');
my $Hook = $SetWindowsHookEx->Call(14, $MouseHookCallback, 0, 0);

#==== keyboard hook implementierung
my $lastdownokay = 0;
my %sammeldowns;
my $id2;
my $dist2 = 150;
sub LowLevelKeyboardProc($$$) 
{
  my ($nCode, $wParam, $lParam) = @_;
  my $vkCode   = ord(unpack("P1",pack('L!',$lParam)));
  #my $flags    = unpack("P1",pack('L!',$lParam+(2*4)));
  print "Keyb: nCode=$nCode, wParam=$wParam, lParam=$lParam, vkCode=".$vkCode.", flags=$flags\n";
  
  my $blockkey = 0;
  if ($vkCode != 0x91)
  {
   if ($wParam == 0x100){$sammeldowns{$vkCode} = 1}else{delete $sammeldowns{$vkCode}}
 
   #if ($sammeldowns{$vk_codes{VK_CTRL}} && $sammeldowns{$vk_codes{VK_KEY_S}}) { $circling_onoff = $circlefix_onoff ^= 1; SB_Info; Win32::GuiTest::SendKeys("{SCROLL}") if ((Win32::GUI::GetKeyState(0x91))[1] != $circlefix_onoff); $blockkey = 1; }
   if ($sammeldowns{$vk_codes{VK_CTRL}} && $sammeldowns{$vk_codes{VK_KEY_S}} && scalar keys %sammeldowns == 2) { $circling_onoff = $circlefix_onoff ^= 1; SB_Info; $blockkey = 1; }
   elsif ($circlefix_onoff && scalar keys %sammeldowns == 1)
   {
    if ($sammeldowns{$vk_codes{VK_KEY_S}}) { $circling_onoff ^= 1; SB_Info; $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_W}}) { if (not($id)){ $timeout = 600; $count = 1; $timeout_smallest = 200; $timeout_steps = 15; $id = $mw->repeat($timeout,\&set_mouse_pos_rect); }else{ $mw->afterCancel($id); $id = ""; } $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_E}}) { if (not($id)){ $timeout = 800; $count = 1; $timeout_smallest = 300; $timeout_steps = 15; $id = $mw->repeat($timeout,\&set_mouse_pos_rect); }else{ $mw->afterCancel($id); $id = ""; } $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_T}}) { if (not($id)){ $timeout = 1000; $count = 1; $timeout_smallest = 300; $timeout_steps = 15; $id = $mw->repeat($timeout,\&set_mouse_pos_rect); }else{ $mw->afterCancel($id); $id = ""; } $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_Z}}) { if (not($id)){ $timeout = 1200; $count = 1; $timeout_smallest = 400; $timeout_steps = 15; $id = $mw->repeat($timeout,\&set_mouse_pos_rect); }else{ $mw->afterCancel($id); $id = ""; } $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_U}}) { if (not($id)){ $timeout = 1500; $count = 1; $timeout_smallest = 400; $timeout_steps = 15; $id = $mw->repeat($timeout,\&set_mouse_pos_rect); }else{ $mw->afterCancel($id); $id = ""; } $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_I}}) { if (not($id)){ $timeout = 2000; $count = 1; $timeout_smallest = 400; $timeout_steps = 15; $id = $mw->repeat($timeout,\&set_mouse_pos_rect); }else{ $mw->afterCancel($id); $id = ""; } $blockkey = 1; }
    #elsif ($sammeldowns{$vk_codes{VK_KEY_Q}}) { $timeout += 20; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_KEY_C}}) { ($config{posx}, $config{posy}) = Win32::GUI::GetCursorPos(); $circling_onoff = ($circling_onoff)?0:1; SB_Info; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_KEY_R}}) { my ($posx, $posy) = ($x_old,$y_old) = Win32::GUI::GetCursorPos(); $config{distance} = sqrt(abs($posx-$config{posx})**2 + abs($posy-$config{posy})**2); $circling_onoff = ($circling_onoff)?0:1; SB_Info; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_F1}}) { $config{mousespeed} /= 0.8; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_F2}}) { $config{mousespeed} *= 0.8; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_F3}}) { $config{distance} /= 0.8; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_F4}}) { $config{distance} *= 0.8; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_F5}}) { $config{distance} += 1; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_F6}}) { $config{distance} -= 1; $blockkey = 1; }
    elsif ($sammeldowns{$vk_codes{VK_KEY_M}}) { $config{mousemode} = ($config{mousemode} == 1)?0:1; $mousemode->selectionClear(0,"end"); $mousemode->selectionSet($config{mousemode}); $blockkey = 1; }
 
    if (defined $shortcuts{$vkCode}) { $config{distance} = $shortcuts{$vkCode}{distance} if ($shortcuts{$vkCode}{distance} ne ""); $config{mousespeed} = $shortcuts{$vkCode}{mousespeed} if ($shortcuts{$vkCode}{mousespeed} ne ""); $config{mousemode} = $shortcuts{$vkCode}{mousemode} if ($shortcuts{$vkCode}{mousemode} ne ""); $config{posx} = $shortcuts{$vkCode}{posx} if ($shortcuts{$vkCode}{posx} ne ""); $config{posy} = $shortcuts{$vkCode}{posy} if ($shortcuts{$vkCode}{posy} ne ""); if ($shortcuts{$vkCode}{mousemode} ne "") { $mousemode->selectionClear(0,"end"); $mousemode->selectionSet($shortcuts{$vkCode}{mousemode}); } }
   }
  }

  my $hookret = $CallNextHookEx->Call(0, $nCode, $wParam, $lParam);
  return ($blockkey || $hookret);
}
my $KeyboardHookCallback = Win32::API::Callback->new(\&LowLevelKeyboardProc, 'NNN', 'I');
my $Hook = $SetWindowsHookEx->Call(13, $KeyboardHookCallback, 0, 0);

#################################################################
###################################################### Mainloop #
#################################################################
MainLoop();
exit 7;
